

#include "testlib.h"

#include <iostream>
#include <cmath>
#include <algorithm>
#include <stdio.h>
#include <cstring>
#include <string>
#include <cstdlib>
#include <vector>
#include <bitset>
#include <map>
#include <chrono>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <queue>
#include <ctime>
#include <stack>
#include <set>
#include <list>
#include <deque>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <stdarg.h>
#include <utility>

#define rng(x) for(int _ = 0; _ < (x); _++)
#define rngi(i, x) for(int i = 0; i < (x); i++)
#define rngsi(s, i, x) for(int i = (s); i <(x); i++)
#define vi vector<int>
using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int m = opt<int>(1);
    int ntree = opt<int>(2);
    int g = opt<int>(3);
    int n = m + ntree;

    cout << n << ' ' << g << '\n';
    
    vi renamed_numbers = rnd.perm(n);

    vector<pair<int,int> > edges;
    for(int i = 0; i < m; i++){
        edges.push_back(make_pair(renamed_numbers[i], renamed_numbers[(i+1)%m]));
    }
    int qq = m;
    rngi(j, m){
        int scur;
        if(j == m - 1) scur = ntree + 1;
        else scur = rnd.next(1, ntree + 1);

        int t = rnd.next(-100, 100);
        vector<int> p(scur);

        vi cur_vertixes;
        cur_vertixes.push_back(renamed_numbers[j]);
        for(int i = qq; i < qq + scur - 1; i++)
        cur_vertixes.push_back(renamed_numbers[i]);

        for(int i = 0; i < scur; i++)
            if (i > 0)
                p[i] = rnd.wnext(i, t);

        vector<int> per(scur);
        for(int i = 0; i < scur; i++)
            per[i] = i;
        shuffle(per.begin() + 1, per.end());

        
        for (int i = 1; i < scur; i++){
            int u = per[i];
            int v = per[p[i]];
            if(rnd.next(2)) swap(u, v);
            edges.push_back(make_pair(cur_vertixes[u], cur_vertixes[v]));
        }
        ntree -= scur - 1;
        qq += scur - 1;
    }
    

    shuffle(edges.begin(), edges.end());
   
    for(auto [x, y] : edges) cout << x + 1 << ' ' << y + 1 << ' '<< rnd.next(1, 1000000000) << '\n';
}