

#include "testlib.h"

#include <iostream>
#include <cmath>
#include <algorithm>
#include <stdio.h>
#include <cstring>
#include <string>
#include <cstdlib>
#include <vector>
#include <bitset>
#include <map>
#include <chrono>
#include <functional>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <queue>
#include <ctime>
#include <stack>
#include <set>
#include <list>
#include <deque>
#include <iomanip>
#include <sstream>
#include <fstream>
#include <stdarg.h>
#include <utility>

#define rng(x) for(int _ = 0; _ < (x); _++)
#define rngi(i, x) for(int i = 0; i < (x); i++)
#define rngsi(s, i, x) for(int i = (s); i <(x); i++)
#define vi vector<int>
using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int n = opt<int>(1);
    int t = opt<int>(2);
    int mxa = opt<int>(3);
    int g = opt<int>(4);
    cout << n << ' ' << g << '\n';
    

    vector<int> p(n);

    for(int i = 0; i < n; i++)
        if (i > 0)
            p[i] = rnd.wnext(i, t);

    vector<int> perm(n);
    for(int i = 0; i < n; i++)
        perm[i] = i;
    shuffle(perm.begin() + 1, perm.end());

    vector<pair<int,int> > edges;
    for (int i = 1; i < n; i++)
        if (rnd.next(2))
            edges.push_back(make_pair(perm[i], perm[p[i]]));
        else
            edges.push_back(make_pair(perm[p[i]], perm[i]));

    shuffle(edges.begin(), edges.end());
    int u = rnd.next(n);
    int v = rnd.next(n);
    auto has = [&](pair<int, int> z){
        return count(edges.begin(), edges.end(), z);
    };
    while(has(make_pair(u, v)) || has(make_pair(v, u))){
        u = rnd.next(n);
        v = rnd.next(n);
    }
    edges.push_back(make_pair(u, v));
    for(auto [x, y] : edges) cout << x + 1 << ' ' << y + 1 << ' '<< rnd.next(1, mxa) << '\n';
}