#include "testlib.h"
#include <string>
#include <vector>
using namespace std;
vector<vector<int> > g;
vector<int> used;
vector<int> par;
vector<int> cyc;
int num = 0;
int con(int v){
    used[v] = 1; num++;
    for(int to : g[v]) if(!used[to]) con(to);
}
int dfs(int v, int p){
    par[v] = p;
    used[v] = 1;
    for(int to : g[v]){
        if(to == p) continue;
        if(used[to]){
            int x = to;
			for (int x = v; x != to; x = par[x])cyc.push_back(x);
			cyc.push_back(to);
            return 1;
        }
        if(dfs(to, v))return 1;
    }
    return 0;
}
int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int n = inf.readInt(3, 200000, "n");
    inf.readSpace();
    int gr = inf.readInt(0, 5, "g");
    ensure(gr == stoi(validator.group()));
    if(gr == 2) ensuref(n <= 200, "Group should contain n <= 200");
    int mxa = (gr == 4 ? 1 : 1e9);
    g.resize(n); used.resize(n); par.resize(n);
    inf.readEoln();
    set<pair<int, int> > ed;
    for(int i =0; i < n; i++){
        int a = inf.readInt(1, n, "a");
        inf.readSpace();
        int b = inf.readInt(1, n, "b");
        inf.readSpace();
        int c = inf.readInt(1, mxa, "c");
        inf.readEoln();
        a--; b--;
        ensuref(a!=b, "Graph should not have self edges");
        ensuref(!ed.count(make_pair(a, b)), "Graph sould not have multiple edges");
        ed.insert(make_pair(a, b));
        ed.insert(make_pair(b, a));
        g[a].push_back(b); g[b].push_back(a);
    }
    ensuref(dfs(0, 0), "Graph does not contain a cycle");
    used.assign(n, 0); con(0);
    ensuref(num == n, "Graph is not connected");
    if(gr == 1) ensuref(cyc.size() == n, "In group 1 graph should be a cycle");
    if(gr == 3) ensuref(cyc.size() <= 1000, "In froup 3 cycle length should be less than 1000");
    inf.readEof();
    
}